#include <iostream>
#include <unistd.h>

#include "PulseAudioCPP.h"
#include "../3rd/vban.h"
#include <sys/socket.h>
#include <arpa/inet.h>

class udpStream
{
public:
	udpStream(std::string target)
	{
		m_socket = socket(AF_INET, SOCK_DGRAM, 0);
		for (int i = 0; i < sizeof(m_addr); i++)
			((char*)&m_addr)[i] = 0;
		m_addr.sin_family = AF_INET;
		m_addr.sin_port = htons(6980);
		inet_aton(target.c_str(), &m_addr.sin_addr);
	}

	virtual ~udpStream() {};

	int send(const char* data, unsigned short size)
	{
		sendto(m_socket, data, size, 0, (struct sockaddr*)&m_addr, sizeof(m_addr));
	}
private:
	int m_socket;
	struct sockaddr_in m_addr;
};

int main()
{
	PulseAudioCPP vbanServer("vban server");

	vbanServer.createStream("testStream");
	VBAN_Stream stream("Stream1", VBAN_CODEC::CODEC_PCM, VBAN_SAMPLERATE::SR_44100, VBAN_DATATYPE::DATATYPE_FLOAT32, 2);

	vbanServer.addObserver(&stream);
	udpStream udp("192.168.10.19");
	
	
	while (1)
	{
		auto packet = stream.getLastPacket();
		if (packet != NULL)
		{
			udp.send(packet->first, packet->second);
			stream.dropLastPacket();
		}
	}
	
	return 0;
}